try:
    import psyco
    psyco.full()
except:
    pass

import sqlite3 as sqlite
import sys

print 'version 3.1'
if len(sys.argv) < 4:
    print 'usage: python %s dbfile snpsfile nr_snps_outfile [-cache numPages] [-repeats]' % sys.argv[0]
    sys.exit(1)

dbfile = sys.argv[1]
filename = sys.argv[2]
outfile = sys.argv[3]
repeats = False

cachePages = 500000
if '-cache' in sys.argv:
    cachePages =  int(sys.argv[sys.argv.index('-cache') + 1])

if '-repeats' in sys.argv:
    repeats = True

db = sqlite.connect(dbfile)
sql = db.cursor()
sql.execute("PRAGMA CACHE_SIZE = %d" % cachePages)
sql.execute("PRAGMA temp_store = MEMORY")

infile = open(filename)
featureList = []
featureDict = {}

for line in infile:
	fields = line.strip().split('\t')
	chrom = fields[2][3:]
        pos = int(fields[3])
	featureList.append((chrom,pos))
	featureDict[(chrom, pos)] = line.strip()
featureList.sort()
currentChrom=''
for (chrom, pos) in featureList:
	if chrom != currentChrom:
		currentChrom = chrom
		try:
			del con
		except:
			pass
		con = sqlite.connect(":memory:")
		sql.execute('select start, stop, name, family from repeats where chrom = "%s"' % chrom)
		results = sql.fetchall()
		results2 = []
		con.execute("create table repeats(name, family, start, stop)")
                con.execute("PRAGMA CACHE_SIZE = %d" % cachePages)
                con.execute("PRAGMA temp_store = MEMORY")
		for (rstart, rstop, name, family) in results:
			results2.append((name, family, int(rstart), int(rstop)))
		con.executemany("insert into repeats(name, family, start, stop) values (?,?,?,?)", results2)
                con.execute("CREATE INDEX posIndex on repeats(start, stop)")
		sql2 = con.cursor()
	featureLength = abs(1)
	results = []
	finalresults = []
	sql2.execute('select family from repeats where start <= %d and stop >= %d' % (pos, pos+1)) 
	results = sql2.fetchall()
        if repeats: # if user wants to keep track of the SNC in repeats
                featureDict[(chrom,pos)] += "\tN\A" 
                for x in results:
                    featureDict[(chrom,pos)] += "\t" + str(x)
        else:
                for x in results:
                        if featureDict.has_key((chrom, pos)):
                                del featureDict[(chrom,pos)]

outF = open(outfile, 'w') 
#outStr = "Sl" + "\t" + "Cl" + "\t" + "chrom" + "\t" + "mis pos" + "\t\t" + "match" + "\t" + "uniq_mis"+ "\t" + "tot_mis" + "\t" + "base_chg" + "\n"
#outF.write(outStr)
for key,value in featureDict.iteritems():
        outStr = str(value) + "\n"
        outF.write(outStr)
outF.close()




