try:
    import psyco
    psyco.full()
except:
    pass

import sqlite3 as sqlite
import sys

print 'version 3.1'
if len(sys.argv) < 4:
    print 'usage: python %s dbfile snpsfile dbsnp_outfile [-cache numPages]' % sys.argv[0]
    sys.exit(1)

dbfile = sys.argv[1]
filename = sys.argv[2]
outfile = sys.argv[3]

cachePages = 500000
if '-cache' in sys.argv:
    cachePages =  int(sys.argv[sys.argv.index('-cache') + 1])
print dbfile
db = sqlite.connect(dbfile)
sql = db.cursor()
sql.execute("PRAGMA CACHE_SIZE = %d" % cachePages)
sql.execute("PRAGMA temp_store = MEMORY")

infile = open(filename)
featureList = []
featureDict = {}

for line in infile:
	fields = line.strip().split('\t')
	chrom = fields[2][3:]
        pos = int(fields[3])
        #print chrom, pos
	featureList.append((chrom,pos))
	featureDict[(chrom, pos)] = line.strip()
featureList.sort()
currentChrom=''
increment = 15000000
for (chrom, pos) in featureList:
	if chrom != currentChrom:
		currentChrom = chrom
		try:
			del con
		except:
			pass
		con = sqlite.connect(":memory:")
		sql.execute('select start, stop, name, func from snp where chrom = "%s"' % chrom)
		results = sql.fetchall()
                #print len(results)
		results2 = []
		con.execute("create table snp(name, func, start, stop)")
                con.execute("PRAGMA CACHE_SIZE = %d" % cachePages)
                con.execute("PRAGMA temp_store = MEMORY")
		for (rstart, rstop, name, func) in results:
			results2.append((name, func, int(rstart), int(rstop)))
		con.executemany("insert into snp(name, func, start, stop) values (?,?,?,?)", results2)
                con.execute("CREATE INDEX posIndex on snp(start, stop)")
		sql2 = con.cursor()
	featureLength = abs(1)
	results = []
	finalresults = []
	sql2.execute('select func, name from snp where start <= %d and stop >= %d' % (pos-1, pos)) 
#        print chrom, pos
	results = sql2.fetchall()
        isSnp = "\tN\A\tN\A"
        for (func, name) in results:
                #print func, name
                isSnp = "\t" + str(name) + "\t" + str(func)
#                print isSnp
        featureDict[(chrom,pos)] += isSnp

outF = open(outfile, 'w') 
#outStr = "Sl" + "\t" + "Cl" + "\t" + "chrom" + "\t" + "mis pos" + "\t\t" + "match" + "\t" + "uniq_mis"+ "\t" + "tot_mis" + "\t" + "base_chg" + "\t" + "known_snp" + "\t" + "function" + "\n"
outStr = ''
outF.write(outStr)
for key,value in featureDict.iteritems():
        outStr = str(value) + "\n"
        outF.write(outStr)
outF.close()




