try:
	import psyco
	psyco.full()
except:
	pass

print 'version 1.3'
from commoncode import *
from cistematic.genomes import Genome
from cistematic.core.geneinfo import geneinfoDB
import sys

if len(sys.argv) < 5:
	print 'usage: %s genome genomesize hitfile outfilename' % sys.argv[0]
	print '\twhere genomesize is in Mbp'
	sys.exit(1)

genome = sys.argv[1]
genomeSize = int(sys.argv[2])
hitfile =  sys.argv[3]
outfilename = sys.argv[4]

standardMinDist = 3000

afile = open(hitfile)
lines = afile.readlines()
hitDictSize = len(lines) - 1
afile.close()
lines = []

hitDict = getReadDict(hitfile, verbose = True)

hg = Genome(genome)
idb = geneinfoDB(cache=True)

gidDict = {}
geneinfoDict = idb.getallGeneInfo(genome)
featuresDict = hg.getallGeneFeatures()

#infile = open(infilename)
outfile = open(outfilename,'w')

gidList = hg.allGIDs()
gidList.sort()
for gid in gidList:
	symbol = 'LOC' + gid
	geneinfo = ''
	featureList = []
	try:
		geneinfo = geneinfoDict[gid]
		featureList = featuresDict[gid]
		symbol = geneinfo[0][0]
	except:
		print geneinfo
	newfeatureList = []
	for (ftype, chrom, start, stop, sense) in featureList:
		if (start, stop) not in newfeatureList:
			newfeatureList.append((start, stop))
	if chrom not in hitDict:
		continue
	newfeatureList.sort()
	if len(newfeatureList) < 1:
		print '%s %s %d' % (gid, symbol, -1)
		outfile.write('%s\t%s\t%d\n' % (gid, symbol, -1))
		continue
	glen = standardMinDist
	if sense == 'F':
		nextGene = hg.leftGeneDistance((genome, gid), glen * 2)
		if nextGene < glen * 2:
			glen = nextGene/2
		if glen < 1:
			glen = 1
		gstart = newfeatureList[0][0] - glen
		if gstart < 0:
			gstart = 0
		gstop = newfeatureList[0][0]
	else:
		nextGene = hg.rightGeneDistance((genome, gid), glen * 2)
		if nextGene < glen * 2:
			glen = nextGene/2
		if glen < 1:
			glen = 1
		gstart = newfeatureList[-1][1]
		gstop = newfeatureList[-1][1] + glen
	tagCount = 0
	tagIndex = 0
	for (tagStart, sense) in hitDict[chrom]:
		if tagStart > gstop:
			break
		if tagStart >= gstart:
			tagCount += 1
		tagIndex += 1
	# we want a tag count RPM also normalized for length
	goodCount = tagCount - hitDictSize * glen / (1000000. * genomeSize)
	RPM = goodCount * 1000000. / hitDictSize
	RPMK =  1000. * RPM / glen
	print '%s %s %d %d %2.3f %2.4f' % (gid, symbol, tagCount, glen, RPM, RPMK)
	outfile.write('%s\t%s\t%d\t%d\t%2.3f\t%2.4f\n' % (gid, symbol, tagCount, glen, RPM, RPMK))
#infile.close()
outfile.close()

