import sys
try:
	import psyco
	psyco.full()
except:
	print 'psyco not running'
from cistematic.core import complement

print 'version 1.0'
if len(sys.argv) < 3:
	print 'usage: python %s outfilename maxBorder\n' % sys.argv[0]
	print '\twhere maxBorder should be readlen - 4\n'
	sys.exit(1)
outfilename = sys.argv[1]
# maxBorder should be readlen - 4
maxBorder = int(sys.argv[2])

datafile = open('knownGene.txt')
seqfile = open('knownGeneMrna.txt')

spliceCountDict = {}
exonStartDict = {}
exonStopDict = {}
exonLengthDict = {}
nameToChromDict = {}
nameToComplementDict = {}
alreadySeen = {}
counter = 0

for line in datafile:
	fields = line.split()
	name = fields[0]
	spliceCount = int(fields[7]) - 1
	if spliceCount < 1:
		continue
	counter += spliceCount
	spliceCountDict[name] = spliceCount
	chrom = fields[1]
	if chrom == 'chrM':
		continue
	nameToChromDict[name] = chrom
	if chrom not in alreadySeen:
		alreadySeen[chrom] = []
	nameToComplementDict[name] = fields[2]
	exonStarts = []
	exonStops = []
	for val in fields[8].split(',')[:-1]:
		exonStarts.append(int(val))
	for val in fields[9].split(',')[:-1]:
		exonStops.append(int(val))
	exonStartDict[name] = exonStarts
	exonStopDict[name] = exonStops
	exonLengths = []
	for index in range(spliceCount + 1):
		exonLengths.append(exonStops[index] - exonStarts[index])
	exonLengthDict[name] = exonLengths
print len(spliceCountDict)
print counter

splicefileindex = 1
seenSpliceList = []
outfile = open(outfilename,'w')
for line in seqfile:
	(name, seq)  = line.strip().split()
	try:
		spliceCount = spliceCountDict[name]
	except:
		continue
	if nameToComplementDict[name] == '-':
		seq = complement(seq)
	exonStarts = exonStartDict[name]
	exonStops = exonStopDict[name]
	exonLengths = exonLengthDict[name]
	exonCumulative = 0
	oldregionstart = 0
	for index in range(spliceCount):
		if (exonStops[index], exonStarts[index + 1]) in alreadySeen[chrom]:
			continue
		alreadySeen[chrom].append((exonStops[index], exonStarts[index + 1]))
		regionstart = exonCumulative + exonLengths[index] - maxBorder
		if regionstart < oldregionstart:
			regionstart = exonCumulative
		exonCumulative += exonLengths[index]
		spliceseq = seq[regionstart:regionstart + 2 * maxBorder]
		outstring = '>%s:%d:%d\n%s\n' % (name, index, regionstart, 'NN' + spliceseq.upper() + 'NN')
		outfile.write(outstring)
	splicefileindex += 1
outfile.close()

