import sys
try:
	import psyco
	psyco.full()
except:
	print 'psyco not running'
from cistematic.core.motif import Motif
from cistematic.genomes import Genome
from commoncode import *

print 'version 1.2'
if len(sys.argv) < 7:
	print 'usage: python %s genome motifFile motThreshold chipbedfile regionfile siteOutfile' % sys.argv[0]
	sys.exit(1)

genome = sys.argv[1]
motfilename = sys.argv[2]
motThreshold = int(sys.argv[3])
chipfilename = sys.argv[4]
infilename = sys.argv[5]
outfilename = sys.argv[6]
maxPvalue = 0.0001

mot = Motif('',motifFile = motfilename)
motLen = len(mot)
bestScore = mot.bestConsensusScore()

hg = Genome(genome)
#genomesize = getGenomesize()
hitDict = getReadDict(chipfilename)

border = 50
regions = getMergedRegions(infilename, 150)

outfile = open(outfilename,'w')

countList = []

posList = []

index = 0
regionList = []

for chrom in regions:
	if 'rand' in chrom or 'M' in chrom:
		continue
	for (start, stop, length) in regions[chrom]:
		(topPos, numHits, smoothArray, numPlus) = findPeak(hitDict[chrom], start, length)
		cstart = start
		cstop = stop
		clength = length
		if numHits > 100:
			ratio = numHits / length
			index = 0
			while smoothArray[index] < ratio:
				index += 1
				cstart += 1
			index = len(smoothArray) - 1
			while smoothArray[index] < ratio:
				index -= 1
				cstop -= 1
			clength = cstart - cstop + 1
		if clength > 2 * border:
			cborder = border
		else:
			cborder = length / 2
		regionList.append((chrom, cstart - cborder, cborder * 2))
		regionList.append((chrom, cstop - cborder, cborder * 2))
	
notFoundIndex = 0
for (chrom, start, length) in regionList:
	seq = hg.sequence(chrom, start, length)
	found = []
	matches = mot.locateMotif(seq, motThreshold)
	for (pos, sense) in matches:
		alreadyFound = False
		for fpos in found:
			if pos + start == fpos:
				alreadyFound = True
		if not alreadyFound:
			found.append(start + pos)
	
	foundValue = False
	for foundpos in found:
		startdist = foundpos - start - border
		seq = hg.sequence(chrom, foundpos, motLen)
		foundValue = True
		(front, back) = mot.scoreMotif(seq)
		sense = '+'
		if front > back:
			score = int(100 * front / bestScore)
		else:
			score = int(100 * back / bestScore)
			sense = '-'
			foundpos + 1
		numHits = -1
		print 'chr%s:%d-%d\t%d\t%d\t%d\tchr%s:%d-%d\t%s' % (chrom, foundpos, foundpos + motLen - 1, score, numHits, startdist, chrom, start+border, start + length - border, sense)
		outfile.write('chr%s:%d-%d\t%d\t%d\t%d\tchr%s:%d-%d\t%s\n' % (chrom, foundpos, foundpos + motLen - 1, score, numHits, startdist, chrom, start + border, start + length - border, sense))
	if not foundValue:
		print 'could not find a %s site for %s:%d-%d' % (mot.tagID, chrom, start, start+ length)
outfile.close()
