#
#  makerdsfrombed.py
#  ENRAGE
#
#  Created by Ali Mortazavi on 6/21/08.
#
try:
    import psyco
    psyco.full()
except:
    pass

import sys
from commoncode import readDataset

print '%s: version 1.2' % sys.argv[0]
if len(sys.argv) < 3:
    print 'usage: python %s label bedfile outdbname [-append] [-RNA] [propertyName::propertyValue]' % sys.argv[0]
    sys.exit(1)

label = sys.argv[1]
filename = sys.argv[2]
outdbname = sys.argv[3]

init = True
if '-append' in sys.argv:
    init = False
dataType = 'DNA'
if '-RNA' in sys.argv:
    dataType = 'RNA'
    
readsize = 0
padsize = 0
index = 0
insertSize = 1000

infile = open(filename,'r')
#infile.readline()

rds = readDataset(outdbname, init, dataType, verbose=True)
if not init:
    rds.dropIndex()

propertyList = []
for arg in sys.argv:
    if '::' in arg:
        (pname, pvalue) = arg.strip().split('::')
        propertyList.append((pname, pvalue))
if len(propertyList) > 0:
    rds.insertMetadata(propertyList)

insertList = []
for line in infile:
    if 'track' in line:
        continue
    fields = line.split()
    if readsize == 0:
        readsize = abs(int(fields[1]) - int(fields[2]))
        if init:
            rds.insertMetadata([('readsize', readsize+1)])
    chrom = fields[0]
    start = int(fields[1])
    stop = int(fields[2])
    sense = fields[5]
    insertList.append((label + '-' + str(index), chrom, start, stop, sense, 1.0, '', ''))
    if index % insertSize == 0:
        rds.insertUniqs(insertList)
        insertList = []
    index += 1

if len(insertList) > 0:
    rds.insertUniqs(insertList)

print '%d unique reads' % index

print 'building index....'
rds.buildIndex()

