print 'version 1.3'
try:
	import psyco
	psyco.full()
except:
	print 'psyco not running'

from commoncode import *

import sys

if len(sys.argv) != 5:
	print 'usage: python %s name chipbedfile chipregionfile outfilename' % sys.argv[0]
	sys.exit(1)

name = sys.argv[1]
readlen = readSize(sys.argv[2], verbose=True)
hitfilename = sys.argv[2]
regionfilename = sys.argv[3]
outfilename = sys.argv[4]

hitDict = getReadDict(hitfilename)
regions = getMergedRegions(regionfilename, 500)

regionList = []
for chrom in regions:
	for (start, stop, length) in regions[chrom]:
		regionList.append((chrom, start, length))
regionList.sort()

outfile = open(outfilename,'w')
outfile.write('track type=wiggle_0 name=%s description=%s visibility=full\n' % (name, name)) 
for (chrom, start, length) in regionList:
	(topPos, numHits, smoothArray, numPlus) = findPeak(hitDict[chrom], start, length, readlen)
	stretchVal = round(smoothArray[0])
	currentStretchStart = 0
	for currentIndex in range(1, length):
		currentVal = round(smoothArray[currentIndex])
		if currentVal == stretchVal:
			continue
		if stretchVal != 0:
			outline = 'chr%s %d %d %d\n' % (chrom, start + currentStretchStart, start + currentIndex, stretchVal)
			outfile.write(outline)
		stretchVal = currentVal
		currentStretchStart = currentIndex
if stretchVal != 0:
	outline = 'chr%s %d %d %d\n' % (chrom, start + currentStretchStart, start + currentIndex, stretchVal)
	outfile.write(outline)

outfile.close()
