import sys

print 'version 1.2'
if len(sys.argv) != 4:
	print 'usage: python %s filename trackType outfilename' % sys.argv[0]
	sys.exit(1)

filename = sys.argv[1]
trackType= sys.argv[2]
outfilename = sys.argv[3]

padsize = 0
readsize = 0

infile = open(filename,'r')
#infile.readline()

outfile = open(outfilename,'w')
outfile.write('track name="%s" visibility=4 itemRgb="On"\n' % trackType)

readid = 0
for line in infile:
	if 'chr' not in line or 'spike' in line:
		continue
	fields = line.split()
        if len(fields) < 4:
            continue
        if fields[3] == 'QC' or fields[3] == 'NM':
            continue
	if readsize == 0:
		readsize = len(fields[1]) - 1
		if readsize > 31:
			padsize = readsize - 31
	#(chrom, start) = fields[3].split(':')
	#sense = fields[4]
	(zero, one, two) = fields[2].split(':')
	zero = int(zero)
	one = int(one)
	two = int(two)
	bestMatch = [False, False, False]
	if zero > 1:
		bestMatch[0] = True
	elif zero == 0 and one > 1:
		bestMatch[1] = True
	elif zero == 0 and one == 0 and two > 1:
		bestMatch[2] = True
	else:
		continue
	readid += 1
	readcount = 0
	bestpos = []
	pos = fields[3].split(',')
	if len(pos) == 1:
		bestpos = pos
	else:
		currentChr = ''
		for apos in pos:
			if ':' in apos:
				try:
					(front, back) = apos.split(':')
				except:
					continue
				currentChr = front
			else:
				apos = currentChr + ':' + apos
			matchType = int(apos[-1])
			if bestMatch[matchType]:
				bestpos.append(apos)
	for apos in bestpos:
		readcount += 1
		(front, back) = apos.split(':')
		chrom = front[:-3]
		start = int(back[:-2])
		sense = back[-2]
		if sense == 'F':
			sense = '+'
			senseCode = '0,0,255'
		else:
			start = start - padsize
			sense = '-'
			senseCode = '255,255,0'
		stop = int(start) + readsize
		outfile.write('%s %d %d %dx%d 0 %s - - %s\n' % (chrom, start, stop, readid, len(bestpos), sense, senseCode))
outfile.close()
print readid

