#!/usr/bin/env python2.3
#
#  regionBins.py
#  ENRAGE
#

try:
    import psyco
    psyco.full()
except:
    print 'psyco not running'

import sys
print '%s: version 1.0' % sys.argv[0]

if len(sys.argv) < 4:
    print 'usage: python %s regionfile hitfile outfilename [-bins numbins] [-field fieldNum] [-normalize] [-padregion bp] [-mergeregion bp]' % sys.argv[0]
    sys.exit(1)

from commoncode import *

regionfilename = sys.argv[1]
readlen = readSize(sys.argv[2], verbose=True)
hitfile =  sys.argv[2]
outfilename = sys.argv[3]

cField = 1
if '-field' in sys.argv:
    fieldIndex = sys.argv.index('-field') + 1
        cField = int(sys.argv[fieldIndex])

if '-normalize' in sys.argv:
    normalize = True
else:
    normalize = False

padregion = 0
if '-padregion' in sys.argv:
    padField = sys.argv.index('-padregion') + 1
    padregion = int(sys.argv[padField])
    print 'padding %d bp on each side of a region' % padregion

mergeregion = 0
if '-mergeregion' in sys.argv:
    mergeField = sys.argv.index('-mergeregion') + 1
    mergeregion = int(sys.argv[mergeField])
    print 'merging regions closer than %d bp' % mergeregion

normalizeBins = False
if '-normalize' in sys.argv:
    normalizeBins = True    

bins = 10
if '-bins' in sys.argv:
    binfield = sys.argv.index('-bins') + 1
    bins = int(sys.argv[binfield])

normalizedtag = 1.
if normalizeBins:
    hitDictSize = datasetSize(hitfile) 
    normalizedTag = 1. / (hitDictSize / 1000000.)


regionDict = getMergedRegions(regionfilename, maxDist = mergeregion, keepLabel = True, verbose = True, chromField = cField, pad=padregion)

hitDict = getReadDict(hitfile, verbose=True)

(regionsBins, regionsLen) = computeRegionBins(regionsByChromDict, hitDict, bins, readlen, normalizedTag)

outfile = open(outfilename, 'w')
for regionID in regionsBins:
    tagCount = 0.
    for binAmount in regionsBins[regionID]:
        tagCount += binAmount
    outfile.write('%s\t%s\t%.1f\t%d' % (regionID, regionID, tagCount, Len[gid]))
    for binAmount in gidBins[gid]:
            if normalizeBins:
                if tagCount == 0:
                    tagCount = 1
                outfile.write('\t%.1f' % (100. * binAmount / tagCount))
            else:
                outfile.write('\t%.1f' % binAmount)
    outfile.write('\n')

outfile.close()