import sys

delimiter = '|'
#delimiter = ':'
print '%s: version 2.1' % sys.argv[0]
if len(sys.argv) < 5:
    print 'usage: python %s ucscGeneModels mapfilename trackname outbedfile [-olddelimiter] [-doColor] [-forward r,g,b] [-reverse r,g,b]' % sys.argv[0]
    sys.exit(1)

genedatafilename = sys.argv[1]
mapfilename = sys.argv[2]
trackname = sys.argv[3]
outfilename = sys.argv[4]

delimiter = '|'
if '-olddelimiter' in sys.argv:
    delimiter = ':'

doColor = False
if '-doColor' in sys.argv:
    doColor = True

forward = '0,0,255'
if '-forward' in sys.argv:
    forward = sys.argv[sys.argv.index('-forward') + 1]

reverse = '255,0,0'
if '-reverse' in sys.argv:
    reverse = sys.argv[sys.argv.index('-reverse') + 1]

geneDict = {}
mapDict = {}

seenSpliceList = []

readsize = 0
maxBorder = 0

genedatafile = open(genedatafilename)
for line in genedatafile:
    fields = line.strip().split('\t')
    blockCount = int(fields[7])
    if blockCount < 2:
        continue
    uname = fields[0]
    chrom = fields[1]
    sense = fields[2]
    chromstarts = fields[8][:-1].split(',')
    chromstops = fields[9][:-1].split(',')
    exonLengths = []
    totalLength = 0
    for index in range(blockCount):
        chromstarts[index] = int(chromstarts[index])
        chromstops[index] = int(chromstops[index])
        exonLengths.append(chromstops[index] - chromstarts[index])
        totalLength += exonLengths[index]
    geneDict[uname] = (sense, blockCount, totalLength, chrom, chromstarts, exonLengths)
    mapDict[uname] = []
genedatafile.close()


outfile = open(outfilename, 'w')
if doColor:
    outfile.write('track name="%s" visibility=4 itemRgb="On"\n' % trackname)
else:
    outfile.write('track name="%s" visibility="4"\n' % trackname)
index = 0
mapfile = open(mapfilename)
for line in mapfile:
    if 'splice' not in line or 'spike' in line:
        continue
    fields = line.strip().split()
    if readsize == 0:
        readsize = len(fields[1])
        maxBorder = readsize - 4
    (zero, one, two) = fields[2].split(':')
    zero = int(zero)
    one = int(one)
    two = int(two)
    bestMatch = [False, False, False]
    if zero == 1:
        bestMatch[0] = True
    elif zero == 0 and one == 1:
        bestMatch[1] = True
    elif zero == 0 and one == 0 and two == 1:
        bestMatch[2] = True
    else:
        continue
    bestpos = []
    pos = fields[3].split(',')
    if len(pos) == 1:
        if 'chr' in pos:
            continue
        bestpos = pos
    else:
        currentSplice = ''
        for apos in pos:
            if apos[:3] == 'chr':
                    continue
            if ':' in apos:
                if delimiter == ':':    
                    (extmodel, spliceID, regionStart, pos) = apos.split(':')
                    currentSplice = extmodel + ':' + spliceID + ':' + regionStart
                else:
                    (currentSplice, pos) = apos.split(':')
            else:
                apos = currentSplice + ':' + apos
    for apos in bestpos:
        if delimiter == ':':
            (extmodel, spliceID, regionStart, pos) = apos.split(':')
        else:
            (currentSplice, pos) = apos.split(':')
            (extmodel, spliceID, regionStart) = currentSplice.split(delimiter)
        model = extmodel.split('/')[1]
        if uname not in geneDict:
            print fields
            continue
        (sense, blockCount, transLength, chrom, chromstarts, blockSizes) = geneDict[model]
        rstart = int(pos[:-2]) - 2
        rsense = pos[-2]
        if rsense == 'F':
            rsense = '+'
            senseCode = forward
        else:
            rsense = '-'
            senseCode = reverse
        #pos = int(fields[7]) - 2
        if 0 < rstart < maxBorder:
            pass
        else:
            continue
        currentSplice = model + delimiter + spliceID + delimiter + regionStart
        spliceID = int(spliceID)
        spliceCount = 0
        cumulative = 0
        #while regionStart > chromstarts[spliceCount]:
        #   spliceCount += 1
        #if sense == '-':
        #   pos = transLength - int(sstart) - pos - readsize
        lefthalf = maxBorder - rstart
        if lefthalf < 1 or lefthalf > maxBorder:
            continue	
        righthalf = readsize - lefthalf
        readstart = int(regionStart)  + rstart
        readstop = chromstarts[spliceID + 1] + righthalf
        readSizes = '%d,%d' % (lefthalf, righthalf)
        readCoords = '0,%d' % (readstop - readstart - righthalf)
        readName = model + '-' + str(pos)
        if doColor:
            outline = '%s\t%d\t%d\t%s\t1000\t%s\t-\t-\t%s\t2\t%s\t%s\n' % (chrom, readstart, readstop, readName, rsense, senseCode, readSizes, readCoords)
        else:
            outline = '%s\t%d\t%d\t%s\t1000\t%s\t-\t-\t-\t2\t%s\t%s\n' % (chrom, readstart, readstop, readName, rsense, readSizes, readCoords)
        index += 1
        if currentSplice not in seenSpliceList:
            seenSpliceList.append(currentSplice)
        outfile.write(outline)
mapfile.close()
outfile.close()

print 'saw %d spliced reads accross %d distinct splices' % (index, len(seenSpliceList))
