#
#  trimquery.py
#  ENRAGE
#
#  Created by Ali Mortazavi on 8/12/08.
#

import sys

print '%s: version 1.5' % sys.argv[0]
if len(sys.argv) < 4:
    print 'usage: python %s length infile outfile [-fromback] [-paired]' % sys.argv[0]
    print '\t where paired fragments are separated by a : when given the -paired flag' 
    sys.exit(1)

length = int(sys.argv[1])
infile = open(sys.argv[2])
outfile = open(sys.argv[3],'w')

paired = False
if '-paired' in sys.argv:
    paired = True
    pairedlength = 2 * length
index = 0
fromBack = False
if '-fromback' in sys.argv:
    fromBack = True
    length = -1 * length

header = ''
for line in infile:
    line = line.strip()
    if line[0] == '>':
        header = line + '\n'
    else:
        if paired:
            if len(line) < pairedlength:
                continue
            outfile.write(header + line[length:] + ':' + line[:length] + '\n')
        else:
            if fromBack:
                outfile.write(header + line[length:] + '\n')
            else:
                outfile.write(header + line[:length] + '\n')
        index += 1
    if index % 1000000 == 0:
        print '.',
        sys.stdout.flush()
outfile.close()
print '%d reads' % index